package commonStructures;
import java.util.HashMap;
import java.util.Iterator;


public class Order {
	private HashMap<String, OrderItem> items; //key: name of item, value: all the object
	private String status = "new";
	private RestaurantTable oTable;
	
	public Order(RestaurantTable aTable){
		items = new HashMap<String, OrderItem>();
		status = "pending";
		oTable = aTable;
		aTable.setOrder(this);
	}
	
	public void addItem(OrderItem m){
		items.put(m.getMIName(), m);
		m.setOrder(this);
	}
	
	public void setStatus(String aStatus){status = aStatus;}
	
	public void setItemStatus(String itemName, String aStatus){
		//TODO: Reduntdant with the next, minimize redundancy
		OrderItem oi = items.get(itemName);
		if (oi == null){ System.out.println("Wrong Item Name"); return;}
		oi.setStatus(aStatus);
	}

	public OrderItem getItem(String itemName){
		OrderItem oi = items.get(itemName);
		if (oi == null){ System.out.println("Wrong Item Name"); return null;}
		return oi;
	}
	
	public RestaurantTable getTable(){return oTable;}
	
	public double getPrice(){
		double price = 0.0;
		
		Iterator<String> iI = items.keySet().iterator();
		while(iI.hasNext()){
			String s = iI.next();
			OrderItem oI = items.get(s);
			//if (oI.getStatus().compareTo("served") !=0) continue;
			price += oI.getMIPrice(); 
		}//end while iteration
		
		return price* 1.13;
	}//end getPrice
	
	public boolean isFullyServed(){
		boolean fullyServed = true;
		
		Iterator<String> iI = items.keySet().iterator();
		while(iI.hasNext()){
			String s = iI.next();
			OrderItem oI = items.get(s);
			if(oI.oiIsFullyServed()==false)
				fullyServed = false;
		}
		return fullyServed;
	}
	
	public String show(){
		String expr = new String("");
		for (String s: items.keySet()){
			OrderItem oI = items.get(s);
			expr += oI.show() + "\n";
		}
		return expr;
	}
	
	public void testStatus(){
		System.out.println("\n----------------Order check---------");
		Iterator<String> iI = items.keySet().iterator();
		while(iI.hasNext()){
			String s = iI.next();
			OrderItem oI = items.get(s);
			System.out.println(oI.getMIName()+" "+oI.getStatus());
		}
		System.out.println("Overall: " + status + "\n--------------------------------------\n");
	}
}
